--- c2hs-0.16.3-orig/src/C2HS/Config.hs	2011-03-25 00:04:59.000000000 +1100
+++ c2hs-0.16.3/src/C2HS/Config.hs	2012-09-16 10:57:54.514595408 +1000
@@ -1,3 +1,4 @@
+{-# LANGUAGE CPP #-}
 --                                                                -*-haskell-*-
 --  ** @configure_input@ **
 --  ===========================================================================
@@ -38,6 +39,10 @@
 
 import Foreign  (toBool)
 import Foreign.C (CInt)
+#if (__GLASGOW_HASKELL__>=705)
+import Foreign.C.Types(CInt(..))
+#endif
+
 import System.Info (arch, os)
 
 -- program settings
--- c2hs-0.16.3-orig/src/Control/StateTrans.hs	2011-03-25 00:04:59.000000000 +1100
+++ c2hs-0.16.3/src/Control/StateTrans.hs	2012-09-16 10:56:52.470863551 +1000
@@ -1,3 +1,4 @@
+{-# LANGUAGE CPP, ScopedTypeVariables #-}
 --  The HiPar Toolkit: state transformer routines
 --
 --  Author : Manuel M. T. Chakravarty
@@ -73,6 +74,10 @@
                    throwExc, fatal, catchExc, fatalsHandledBy)
 where
 
+#if !MIN_VERSION_base(4,6,0)
+import Prelude hiding (catch)
+#endif
+import Control.Exception (catch, IOException)
 
 -- BEWARE! You enter monad country. Read any of Wadler's or
 -- Launchbury/Peyton-Jones' texts before entering. Otherwise,
@@ -296,7 +301,7 @@
                                   ioError err
               Right _a         -> return state
             )
-            `catch` (\err -> let
+            `catch` (\(err :: IOException) -> let
                                STB handler' = handler err
                              in
                              handler' bs gs)
